module Main where

import Data.List
import Data.Word 
import Data.Bits
import Array
import Numeric
import IO
import Data.Array.IO
import qualified Data.Map as Map

type Bigits = Int

data BInstr = MATH    Bigits Bigits Bigits
            | LOGIC   Bigits Bigits Bigits
            | SCIENCE Bigits
            | PHYSICS Bigits
  deriving (Eq,Show)

toBigits :: Bigits -> String
toBigits x =
    let
        bvec = [(\b -> if (testBit x b) then '1' else '0') i | i <- [7,6..0]]
    in
      bvec

bin2hex :: String -> String
bin2hex (a:b:c:d:str) = showHex n (bin2hex str) 
 where n = ((if a == '1' then 8 else 0) +
            (if b == '1' then 4 else 0) +
            (if c == '1' then 2 else 0) +
            (if d == '1' then 1 else 0))
bin2hex [] = []
bin2hex x  = error "bin2hex: malsized bin pattern"


byteMe:: BInstr -> String
byteMe (MATH a b c) = bin2hex ("001" ++
                      (drop 7 (toBigits a)) ++
                      (drop 6 (toBigits b)) ++
                      (drop 6 (toBigits c)))
byteMe (LOGIC a b c)= bin2hex ("010" ++
                      (drop 7 (toBigits a)) ++
                      (drop 6 (toBigits b)) ++
                      (drop 6 (toBigits c)))
byteMe (SCIENCE a)  = bin2hex ("000" ++
                      (drop 3 (toBigits a)))
byteMe (PHYSICS a)  = bin2hex ("011" ++
                      (drop 3 (toBigits a)))

genProg xs = concatMap byteMe xs
                        

b = [PHYSICS 1, PHYSICS (-15),
     SCIENCE 1,
     PHYSICS 1, PHYSICS 2, PHYSICS 3,
     PHYSICS (-2), PHYSICS (1), PHYSICS (-3),
     SCIENCE 3
    ]

--([(2,0),(3,0),(0,1),(1,1),(5,13),(4,12)],[-3,1,-2,3,2,1])
--([(2,0),(3,0),(0,1),(1,1),(5,13),(4,12)],[-2,3,1,-3,2,1])
   

bal = [PHYSICS (1),
       PHYSICS (-3),
       PHYSICS (-1),
       PHYSICS (5),
       PHYSICS (-4),
       MATH 0 1 2,
       PHYSICS (-1),
       SCIENCE 0
      ]

bal' = [PHYSICS (-8),PHYSICS (8),PHYSICS (8),PHYSICS (-16)]

bal'' = [PHYSICS 2, PHYSICS (-4),MATH 0 0 3, SCIENCE 0]

bal''' = [PHYSICS (-16), PHYSICS (-8), PHYSICS 8, PHYSICS 8, SCIENCE 0]
type C = [(Int, Int)]

phys :: Int -> C -> C 
phys 17 conf = map (\(a,x) -> (a,x - 1))  conf
phys n conf = 
    let
        bs           = [(testBit n i, conf !! (5 -i))| i <- [0..4]]
        f last []    = [last]
        f last ((xb,xv):xs) = if xb then
                                last : (f xv xs)
                              else
                                xv : (f last xs)
        (ch,i) = (conf!!0)
        newconf = (reverse (f (ch,i+n) bs))
    in
      newconf


{- for swapreg2
matchf :: (C,[Int]) -> Bool
matchf (x,_) = let
                 g (orig, i) = (i  == 0) &&
                               (i' == 0) &&
                               orig' /= orig &&
                               fst (x !! orig') == orig
                                   where
                                     (orig', i') = (x !! orig)
               in
                 (any g x) 
-}
{-
matchf :: (C,[Int]) -> Bool
matchf (x,_) = (any (\(_,x)->1==x) (take 4 x)) &&
               (any (\(_,x)->0==x) (take 4 x)) &&
               (any (\(_,x)->2==x) (drop 4 x)) 
-}
{-
matchf :: (C,[Int]) -> Bool
matchf (x,_) = let
                 g (orig, i) = (i  == 0) &&
                               (i' == 0) &&
                               orig' /= orig &&
                               fst (x !! orig') == orig
                                   where
                                     (orig', i') = (x !! orig)
               in
                 (any g x)
-}
matchf :: (C,[Int]) -> Bool
matchf (x,_) = let
                 (o0,v0) = x !! 0
               in
                 (o0 == 0) &&
                 (v0 == 0) &&
                 (length $ filter (\(_,x)->1==x) (take 4 x)) >= 2 && 
                 (any (\x->(x== (4,12))) (drop 4 x)) && 
                 (any (\x->(x== (5,13))) (drop 4 x))

initconf :: C
initconf = [(0,0),
            (1,0),
            (2,0),
            (3,0),
            (4,12),
            (5,13)]

pf :: [(C,[Int])]-> [(C,[Int])]
pf cs = [(phys n c, n:hist) |
              n <- [0]++[(-16)..(-1)]++[1..15],
              (c,hist) <- cs]

p :: [[(C,[Int])]]
p = iterate pf [(initconf,[])]


matches = map (filter matchf) (iterate pf [(initconf,[])])

--main = do
--  putStrLn (show (matches !! 5))

--putStrLn $ unlines (map show (matches !! 0))

main :: IO ()
main =
    do 
      putStrLn $unlines (map show (matches !! 8))
               