#include <stdio.h>
#include <string>
#include <vector>
#include <list>
using namespace std;

#include "File.hpp"
#include "State.hpp"
#include "Exec.hpp"

int main(int argc, char *argv[])
{
  if (argc < 2) {
    printf("Usage: cinterp <program> [<input> ...]\n");
    return 1;
  }

  string progFile(argv[1]);
  list<ifstream *> inputs;
  for (int i = 2; i < argc; ++i) {
    inputs.push_back(new ifstream(argv[i]));
  }

  vector<unsigned char> bytes;

  if (!readFile(progFile, &bytes)) {
    printf("Could not read file\n");
    return 1;
  }

  if (bytes.size() % 4 != 0) {
    printf("Not a multiple of four bytes\n");
    return 1;
  }

  //printf("Read file size = %d.\n", bytes.size());

  unsigned int sz = bytes.size() / 4; 
  State state;
  state.m_inputs = inputs;
  state.m_array0 = new vector<Platter>();
  vector<Platter> &mem = *(state.m_array0);
  mem.resize(sz);
  for (unsigned int i = 0; i < sz; i++) {
    mem[i] =
      (((unsigned int)(bytes[i * 4 + 0])) << 24) +
      (((unsigned int)(bytes[i * 4 + 1])) << 16) +
      (((unsigned int)(bytes[i * 4 + 2])) << 8) +
      (((unsigned int)(bytes[i * 4 + 3])));
    //printf("mem[%d] = %08x\n", i, mem[i]);
  }

  exec(state);

  return 0;
}
