module Flags where

import System.Console.GetOpt
import System
import Numeric
import UniversalMachine
import Data.Word

data Flags = Flags { dump_start :: Word64, verbose :: Bool }

default_flags :: Flags
default_flags = Flags { verbose = False, dump_start = 0xffffffff }

options :: [OptDescr (Flags -> Flags)]
options = [
           Option [] ["dump"] (ReqArg (\s fs -> fs { dump_start = fromHex s }) "N") "start dumping at cycle N (hex)",
           Option ['v'] ["verbose"] (NoArg (\fs -> fs { verbose = True })) "chatter more"
          ]

fromHex s = case readHex s of
               [(n, "")] -> n
               _ -> error ("*** not a number: " ++ s ++ " ***")

parse_flags :: [String] -> IO (Flags, [String])
parse_flags args = 
   case (getOpt Permute options args) of
      (fs,s,[]  ) -> let flags = foldl (flip ($)) default_flags fs
		     in  return (flags, s)
      (_,_,errs)  -> mapM_ putStrLn errs >> exitWith (ExitFailure 1)
